.486
.model flat, stdcall
option casemap: none

; API functions
; ------------------------------------------------------------------------------
include \masm32\include\windows.inc 
include \masm32\include\masm32.inc
include \masm32\macros\macros.asm
include \masm32\include\user32.inc 
include \masm32\include\kernel32.inc
include \masm32\include\comctl32.inc 
include \masm32\include\comdlg32.inc
include \masm32\include\gdi32.inc
include \masm32\include\shell32.inc
include \masm32\include\oleaut32.inc
include \masm32\include\ole32.inc

includelib \masm32\lib\masm32.lib
includelib \masm32\lib\user32.lib 
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comctl32.lib 
includelib \masm32\lib\comdlg32.lib 
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\oleaut32.lib
includelib \masm32\lib\ole32.lib

include BmpFrom.inc
; ------------------------------------------------------------------------------

; Prototype 
; ------------------------------------------------------------------------------
DialogProc PROTO : HWND, : UINT, : WPARAM, : LPARAM

.const

; Resource ids
; ------------------------------------------------------------------------------
IDD_DLG1  		equ 101
IDI_ICON        equ 200

; Required data

.data
szTitle       TCHAR "Wavering Text Example", 0

; Logo stuff
LogoWidth    dd 149
LogoHeight   dd 49
dwX          dd 0
dwY          dd 0
logofrequency	   real4 15.0
logoamplitude	   real4 3.0
rectLogo     RECT <0,0,300,78> ; Size of the area were the text will waver

LogBrush     LOGBRUSH <>
LFont        LOGFONT <>
rect         RECT <>
; Dialog background colour
DlgBGCol     dd 008FBCB9h;00000000h 
.data?
;
hInstance HINSTANCE ?
hIcon     HICON     ?
; Dialog Brush
hDlgBGBrush  dd ?
; Logo stuff
hLogoBmp     dd ?
hDCLogo      dd ?
hOldLogo     dd ?  
hBuf         dd ?
hDCBuf       dd ?
hOldBuf      dd ?
hBuf2        dd ?
hDCBuf2      dd ?
hOldBuf2     dd ?
hDC          dd ?


.code

start:
INVOKE GetModuleHandle, NULL
mov hInstance, eax

INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax
INVOKE InitCommonControls
INVOKE CoInitialize,NULL

; ---------------------------------------------
;   Call the dialog box stored in resource file
; ---------------------------------------------
INVOKE DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, 0
INVOKE CoUninitialize           ; all done with COM
INVOKE ExitProcess, 0


; Dialog procedure
; ------------------------------------------------------------------------------
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM

LOCAL off_set:DWORD

 .IF uMsg == WM_INITDIALOG

  INVOKE SetWindowText, hWnd, addr szTitle 
  INVOKE SendMessage, hWnd, WM_SETICON,ICON_SMALL, hIcon
  
  INVOKE BmpFromResource,hInstance,50             ; Load logo bitmap into memory
   mov hLogoBmp,eax                                ; Save it's handle  
  
; INVOKE  GetClientRect,hWnd,ADDR rectLogo ; Get the .rc Window rect size
; Setup up our brush for the dialog background colour
mov eax,DlgBGCol
mov LogBrush.lbColor,eax
invoke CreateBrushIndirect,ADDR LogBrush
mov hDlgBGBrush,eax

  ; Setup up our text scroller
    invoke SetTimer,hWnd,1,0,0
    invoke GetDC,hWnd
    mov	hDC,eax
    invoke CreateCompatibleDC,eax
  
; Setup the logo stuff
invoke CreateCompatibleDC,hDC
mov	hDCBuf,eax
invoke CreateCompatibleBitmap,hDC,280,90
mov	hBuf,eax
invoke SelectObject,hDCBuf,eax
mov hOldBuf,eax
invoke CreateCompatibleDC,hDC
mov	hDCBuf2,eax
invoke CreateCompatibleBitmap,hDC,280,90
mov	hBuf2,eax
invoke SelectObject,hDCBuf2,eax
mov hOldBuf2,eax
invoke CreateCompatibleDC,hDC
mov	hDCLogo,eax
invoke SelectObject,hDCLogo,hLogoBmp
mov hOldLogo,eax


    .ELSEIF uMsg == WM_COMMAND
    .ELSEIF uMsg == WM_ERASEBKGND
invoke GetClientRect,hWnd,ADDR rect
invoke FillRect,wParam,ADDR rect,hDlgBGBrush
 ret
; Update our logo

.ELSEIF uMsg == WM_TIMER

	  invoke FillRect,hDCBuf,ADDR rectLogo,hDlgBGBrush
  		  invoke FillRect,hDCBuf2,ADDR rectLogo,hDlgBGBrush
        inc dwX
        mov eax,logofrequency
		    .if dwX == eax
		      mov dwX,0
		    .endif

   xor ecx,ecx
        mov off_set,0 
        .while ecx < 260
      		fild dwX
      		fild off_set
      		fadd
      		fdiv logofrequency
      		fsin
      		fmul logoamplitude
      		fistp dwY
      		add dwY,3 ; Centers up & Down 
	        invoke BitBlt,hDCBuf,off_set,dwY,1,LogoHeight,hDCLogo,off_set,0,SRCCOPY
    		  inc off_set
    		  mov ecx,off_set
    	  .endw

        xor ecx,ecx
        mov off_set,0  ; Centers up & Down 
        .while ecx < 78
      		fild dwX
      		fild off_set
      		fadd
      		fdiv logofrequency
      		fsin
      		fmul logoamplitude
      		fistp dwY
      		add dwY,120 ; Centers Side To Dide 
	        invoke BitBlt,hDCBuf2,dwY,off_set,LogoWidth,1,hDCBuf,0,off_set,SRCCOPY
    		  inc off_set
    		  mov ecx,off_set
    	  .endw

		    invoke BitBlt,hDC,0,0,rectLogo.right,rectLogo.bottom,hDCBuf2,0,0,SRCCOPY


 
    .ELSEIF uMsg == WM_DESTROY 

        invoke SelectObject,hDCBuf,hOldBuf
        invoke SelectObject,hDCBuf2,hOldBuf2
        invoke SelectObject,hDCLogo,hOldLogo
        invoke DeleteObject,hLogoBmp
        invoke DeleteObject,hBuf
        invoke DeleteObject,hBuf2
        invoke DeleteObject,hDlgBGBrush
        invoke DeleteDC,hDCLogo
        invoke DeleteDC,hDCBuf
        invoke DeleteDC,hDCBuf2
        invoke ReleaseDC,hWnd,hDC
 
 
    .ELSEIF uMsg == WM_CLOSE
    INVOKE EndDialog, hWnd, 0
 .ENDIF

    xor eax,eax
  ret
DialogProc endp

end start